From c967384fcfd9f6288a0d3ef31b68d53156c3285a Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 16 2020 00:38:22 +0000
Subject: [PATCH 1408/2232] Emit pins in macro expansion


---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 903585e..eaa7928 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -244,10 +244,15 @@ fn expand_cxx_function_shim(efn: &ExternFn, types: &Types) -> TokenStream {
     let doc = &efn.doc;
     let decl = expand_cxx_function_decl(efn, types);
     let receiver = efn.receiver.iter().map(|receiver| {
-        let ampersand = receiver.ampersand;
-        let mutability = receiver.mutability;
         let var = receiver.var;
-        quote!(#ampersand #mutability #var)
+        if receiver.pinned {
+            let ty = receiver.ty();
+            quote!(#var: #ty)
+        } else {
+            let ampersand = receiver.ampersand;
+            let mutability = receiver.mutability;
+            quote!(#ampersand #mutability #var)
+        }
     });
     let args = efn.args.iter().map(|arg| quote!(#arg));
     let all_args = receiver.chain(args);
diff --git a/syntax/tokens.rs b/syntax/tokens.rs
index 0d6c066..40ab723 100644
--- a/syntax/tokens.rs
+++ b/syntax/tokens.rs
@@ -54,10 +54,17 @@ impl ToTokens for Ty1 {
 
 impl ToTokens for Ref {
     fn to_tokens(&self, tokens: &mut TokenStream) {
+        if let Some((pin, langle, _rangle)) = self.pin_tokens {
+            tokens.extend(quote_spanned!(pin.span=> ::std::pin::Pin));
+            langle.to_tokens(tokens);
+        }
         self.ampersand.to_tokens(tokens);
         self.lifetime.to_tokens(tokens);
         self.mutability.to_tokens(tokens);
         self.inner.to_tokens(tokens);
+        if let Some((_pin, _langle, rangle)) = self.pin_tokens {
+            rangle.to_tokens(tokens);
+        }
     }
 }
 
@@ -172,9 +179,16 @@ impl Receiver {
 
 impl ToTokens for ReceiverType<'_> {
     fn to_tokens(&self, tokens: &mut TokenStream) {
+        if let Some((pin, langle, _rangle)) = self.0.pin_tokens {
+            tokens.extend(quote_spanned!(pin.span=> ::std::pin::Pin));
+            langle.to_tokens(tokens);
+        }
         self.0.ampersand.to_tokens(tokens);
         self.0.lifetime.to_tokens(tokens);
         self.0.mutability.to_tokens(tokens);
         self.0.ty.to_tokens(tokens);
+        if let Some((_pin, _langle, rangle)) = self.0.pin_tokens {
+            rangle.to_tokens(tokens);
+        }
     }
 }

